aboutsummaryrefslogtreecommitdiff
path: root/share/hydractl/backup-restore-puppet
diff options
context:
space:
mode:
authorSilvio Rhatto <rhatto@riseup.net>2014-03-08 18:08:00 -0300
committerSilvio Rhatto <rhatto@riseup.net>2014-03-08 18:08:00 -0300
commitf38543090ddb792adb5be7af5946c87b28a8ac32 (patch)
tree962cb12e250585e96adef1af5e73014236a800b3 /share/hydractl/backup-restore-puppet
parentcb732a2470cf9fce851a2bce376a2f2ca032f5af (diff)
downloadhydra-f38543090ddb792adb5be7af5946c87b28a8ac32.tar.gz
hydra-f38543090ddb792adb5be7af5946c87b28a8ac32.tar.bz2
Adding backup-restore-puppet and minor backup fixes
Diffstat (limited to 'share/hydractl/backup-restore-puppet')
-rwxr-xr-xshare/hydractl/backup-restore-puppet65
1 files changed, 65 insertions, 0 deletions
diff --git a/share/hydractl/backup-restore-puppet b/share/hydractl/backup-restore-puppet
new file mode 100755
index 0000000..a36a361
--- /dev/null
+++ b/share/hydractl/backup-restore-puppet
@@ -0,0 +1,65 @@
+#!/bin/bash
+#
+# Restore puppet configuration, keys, certificates and runtime data.
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU Affero General Public License as
+# published by the Free Software Foundation, either version 3 of the
+# License, or (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU Affero General Public License for more details.
+#
+# You should have received a copy of the GNU Affero General Public
+# License along with this program. If not, see
+# <http://www.gnu.org/licenses/>.
+
+# Load
+source $APP_BASE/lib/hydra/functions || exit 1
+hydra_config_load
+
+# Command line arguments
+BASENAME="`basename $0`"
+
+# Parameters.
+HOST="$1"
+SERVICE="apache2"
+SERVICE_DIR="/var/lib/puppetmaster"
+SERVICE_USER="puppet"
+SERVICE_GROUP="puppet"
+
+# Check environment
+if [ ! -f "/var/git/repositories/puppet.git/config" ]; then
+ echo "fatal: you have to restore /var/git/repositories/puppet.git first"
+ exit 1
+fi
+
+# Set restore environment.
+hydra_backup_environment_service
+
+# TODO: Backup $SERVICE_DIR and /etc/puppet
+
+# Stop services
+/etc/init.d/puppet stop
+/etc/init.d/$service stop
+
+# Remove current folder
+rm -rf $SERVICE_DIR
+rm -rf /etc/puppet
+
+# Clone puppet configuration
+git clone /var/git/repositories/puppet.git/ /etc/puppet/
+( cd /etc/puppet && git submodule update --init --recursive )
+
+# Copy site folder from backup.
+cp -a $RESTOREDIR/$SERVICE_DIR $SERVICE_DIR
+
+# Fix permissions.
+chown -R $SERVICE_USER.$SERVICE_GROUP $SERVICE_DIR
+chown -R $SERVICE_USER.$SERVICE_GROUP /etc/puppet
+
+# Start services
+/etc/init.d/$service start
+/etc/init.d/puppet start